;------------------------------------------------------------
; Cdigo assembler generado por Niple V5.6.4
; Proyecto: piro
; Autor: JUAN DIEGO FLORES
; Fecha: 12/03/2016
; PIC: 16F88
; Velocidad de reloj: Int 4 Mhz
; Descripcion: 
;------------------------------------------------------------


 LIST    P=PIC16F88


_INTRC_IO             equ  0x3FFC
_DEBUG_OFF            equ  0x3FFF
_LVP_OFF              equ  0x3F7F
_CPD_OFF              equ  0x3FFF
_CP_OFF               equ  0x3FFF
_MCLRE_ON             equ  0x3FFF
_PWRTE_ON             equ  0x3FF7
_WDT_OFF              equ  0x3FFB
_INTRC_IO             equ  0x3FFC
_WRT_OFF              equ  0x3FFF
_FCMEN_OFF            equ  0x3FFE
_IESO_OFF             equ  0x3FFD
_config1              equ  0x2007
_config2              equ  0x2008

 __config _config1, _INTRC_IO & _DEBUG_OFF & _LVP_OFF & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _WRT_OFF
 __config _config2, _FCMEN_OFF & _IESO_OFF


;------------------------------------------------------------
;                  Declaracin de Registros
;------------------------------------------------------------
w                     equ  0x0000
pcl                   equ  0x0002
status                equ  0x0003
porta                 equ  0x0005
portb                 equ  0x0006
pclath                equ  0x000a
adresh                equ  0x001e
adcon0                equ  0x001f
lectura_l             equ  0x0024
lectura_h             equ  0x0025
valor                 equ  0x0026
valor_uni             equ  0x0027
valor_dec             equ  0x0028
valor_cen             equ  0x0029
_np_temp1             equ  0x002a
_np_temp2             equ  0x002b
_np_temp3             equ  0x002c
_np_temp4             equ  0x002d
_np_temp5             equ  0x002e
_np_temp6             equ  0x002f
_np_temp7             equ  0x0030
_np_temp8             equ  0x0031
_np_temp9             equ  0x0032
_np_temp10            equ  0x0033
_np_temp11            equ  0x0034
_np_temp12            equ  0x0035
_np_temp13            equ  0x0036
_np_temp14            equ  0x0037
_np_temp15            equ  0x0038
_np_temp16            equ  0x0039
_np_tiempo            equ  0x003a
_np_tiempo1           equ  0x003b
_np_tiempo2           equ  0x003c
_np_tiempo3           equ  0x003d
_np_resultado         equ  0x0043
_np_indice            equ  0x0044
_np_bcd_temp1         equ  0x0045
_np_bcd_temp2         equ  0x0046
_np_bcd_temp3         equ  0x0047
repe                  equ  0x0048
trisa                 equ  0x0085
trisb                 equ  0x0086
osccon                equ  0x008f
ansel                 equ  0x009b
cmcon                 equ  0x009c
adresl                equ  0x009e
adcon1                equ  0x009f


;------------------------------------------------------------
;                  Declaracin de Bits
;------------------------------------------------------------
adfm                  equ  7   ;
adon                  equ  0   ;
c                     equ  0   ;carry / borrow bit
chs0                  equ  3   ;
chs1                  equ  4   ;
chs2                  equ  5   ;
go_done               equ  2   ;
ra1                   equ  1   ;bit 1 del puerto a
ra2                   equ  2   ;bit 2 delpuerto a
ra3                   equ  3   ;bit 3 del puerto a
rp0                   equ  5   ;registrer bank select bit
rp1                   equ  6   ;registrer bank select bit
z                     equ  2   ;bit cero


;------------------------------------------------------------
;               Declaracin de Registros EEPROM
;------------------------------------------------------------


;------------------------------------------------------------
;                        Inicio
;------------------------------------------------------------

   org 0x00
   goto paso2

piro2
   movf _np_indice,0
   movwf _np_temp1
   movlw low piro2_tabla
   addwf _np_temp1,1
   movlw high piro2_tabla
   btfsc status,c
   addlw .1
   movwf pclath
   movf _np_indice,0
   call piro2_tabla
   movwf _np_resultado
   return

piro2_tabla
   addwf pcl,1
   retlw 0xee                       ; cero
   retlw 0xc0                       ; uno
   retlw 0x5e                       ; dos
   retlw 0xdc                       ; tres
   retlw 0xf0                       ; cuatro
   retlw 0xbc                       ; cinco
   retlw 0xbe                       ; seis
   retlw 0xc8                       ; siete
   retlw 0xfe                       ; ocho
   retlw 0xf8                       ; nueve


;------------------------------------------------------------
;                      programa principal
;------------------------------------------------------------
paso2
   movlw b'01101100'
   bsf status,rp0                   ;cambiar a banco 1
   bcf status,rp1
   movwf osccon
   bcf status,rp0                   ;cambiar a banco 0
   clrf lectura_l
   clrf lectura_h
   clrf valor
   clrf valor_uni
   clrf valor_dec
   clrf valor_cen
   clrf _np_temp1
   clrf _np_temp2
   clrf _np_temp3
   clrf _np_temp4
   clrf _np_temp5
   clrf _np_temp6
   clrf _np_temp7
   clrf _np_temp8
   clrf _np_temp9
   clrf _np_temp10
   clrf _np_temp11
   clrf _np_temp12
   clrf _np_temp13
   clrf _np_temp14
   clrf _np_temp15
   clrf _np_temp16
   clrf _np_tiempo
   clrf _np_tiempo1
   clrf _np_tiempo2
   clrf _np_tiempo3
   clrf _np_resultado
   clrf _np_indice
   clrf _np_bcd_temp1
   clrf _np_bcd_temp2
   clrf _np_bcd_temp3
   clrf repe
   clrf porta
   movlw b'00000000'
   bsf status,rp0                   ;cambiar a banco 1
   movwf adcon1
   bcf status,rp0                   ;cambiar a banco 0
   bsf adcon0,0
   bsf status,rp0                   ;cambiar a banco 1
   bsf ansel,0
   bcf ansel,1
   bcf ansel,2
   bcf ansel,3
   bcf ansel,4

   bcf status,rp0                   ;cambiar a banco 0
   bsf adcon0,adon                  ;activar activar el mdulo de conv a/d
   movlw b'10100001'                ;configurar el puerto a como esessssa
   bsf status,rp0                   ;cambiar a banco 1
   movwf trisa
   movlw .7
   movwf cmcon
   bcf status,rp0                   ;cambiar a banco 0
   clrf portb
   bsf status,rp0                   ;cambiar a banco 1
   bcf ansel,5
   bcf ansel,6
   movlw b'00000000'                ;configurar el puerto b como ssssssss
   movwf trisb
paso4
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   bcf adcon0,chs0
   bcf adcon0,chs1
   bcf adcon0,chs2
   bsf adcon0,6
   bcf adcon0,7
   bsf status,rp0                   ;cambiar a banco 1
   bsf adcon1,adfm                  ;alinear el resultado a la derecha
   bcf status,rp0                   ;cambiar a banco 0
   clrf _np_temp3
   clrf _np_temp4
   movlw .4
   movwf _np_temp5
paso4_ciclos
   movlw .10
   movwf _np_temp1
paso4_t
   decfsz _np_temp1,1
   goto paso4_t
   bsf adcon0,go_done
   nop
   nop
paso4_f
   btfsc adcon0,go_done
   goto paso4_f
   bsf status,rp0                   ;cambiar a banco 1
   movf adresl,w                    ;recuperar el registro bajo de la conversion a/d
   bcf status,rp0                   ;cambiar a banco 0
   movwf lectura_l
   movf adresh,w                    ;recuperar el registro alto de la conversion a/d
   movwf lectura_h
   movf lectura_l,w
   addwf _np_temp4,1
   btfsc status,c
   incf _np_temp3,1
   movf lectura_h,w
   addwf _np_temp3,1
   movlw .1                         ;temporizador 1 mse
   call tmp_1_mc                    ;llamada a rutina tmp_1_mc
   decfsz _np_temp5,1
   goto paso4_ciclos
   bcf status,c
   rrf _np_temp3,1
   rrf _np_temp4,1
   bcf status,c
   rrf _np_temp3,1
   rrf _np_temp4,1
   movf _np_temp3,w
   movwf lectura_h
   movf _np_temp4,w
   movwf lectura_l
   movlw .1                         ;temporizador 10 mse
   call tmp_100_mc                  ;llamada a rutina tmp_100_mc
   movlw .0
   movwf _np_temp1
   movlw .25
   movwf _np_temp2
   call multi_100_dec               ;llamada a rutina multi_100_dec
   movf lectura_h,w
   movwf _np_temp1
   movf lectura_l,w
   movwf _np_temp2
   call multi_16                    ;llamada a rutina multi_16
   movf _np_temp10,w
   movwf _np_temp4
   movf _np_temp11,w
   movwf _np_temp3
   movf _np_temp12,w
   movwf _np_temp2
   movf _np_temp13,w
   movwf _np_temp1
   clrf _np_temp8
   clrf _np_temp7
   clrf _np_temp6
   movlw .100
   movwf _np_temp5
   call division_32                 ;llamada a rutina division_32
   movf _np_temp1,w
   movwf valor
   movlw .255
   subwf _np_temp1
   btfss status,c
   goto paso6_a
   movlw .255
   movwf valor
paso6_a
   ;convertir un registro a bcd
   movf valor,w
   movwf _np_bcd_temp1
   call conv_8_bcd                  ;llamada a rutina conv_8_bcd
   movf _np_bcd_temp1,w
   movwf valor_uni
   movf _np_bcd_temp2,w
   movwf valor_dec
   movf _np_bcd_temp3,w
   movwf valor_cen
   clrf repe
paso9

   movlw d'100'                     ;si el -reg(08), repe  < d'100', 
   subwf repe,w
   btfsc status,c
   goto paso4
   incf repe,1
   movf valor_cen,w                 ;consultar la tablapiro2
   movwf _np_indice
   call piro2                       ;llamada a rutina piro2
   movf _np_resultado,w
   movwf valor
   ;escribir en el puerto b
   movf valor,w
   movwf portb
   bsf porta,ra3
   movlw .5                         ;temporizador 5 mse
   call tmp_1_mc                    ;llamada a rutina tmp_1_mc
   bcf porta,ra3
   movf valor_dec,w                 ;consultar la tablapiro2
   movwf _np_indice
   call piro2                       ;llamada a rutina piro2
   movf _np_resultado,w
   movwf valor
   ;escribir en el puerto b
   movf valor,w
   movwf portb
   bsf porta,ra2
   movlw .5                         ;temporizador 5 mse
   call tmp_1_mc                    ;llamada a rutina tmp_1_mc
   bcf porta,ra2
   movf valor_uni,w                 ;consultar la tablapiro2
   movwf _np_indice
   call piro2                       ;llamada a rutina piro2
   movf _np_resultado,w
   movwf valor
   ;escribir en el puerto b
   movf valor,w
   movwf portb
   bsf porta,ra1
   movlw .5                         ;temporizador 5 mse
   call tmp_1_mc                    ;llamada a rutina tmp_1_mc
   bcf porta,ra1
   goto paso9                       ;cierra el ciclo


;------------------------------------------------------------
;                  Declaracin de Subrutinas
;------------------------------------------------------------

tmp_1_mc
   movwf _np_tiempo
   goto tmp_1_mc_1
tmp_1_mc_bucle1
   nop
   nop
   nop
   nop
   nop
   nop
   nop
tmp_1_mc_1
   movlw .246
   movwf _np_tiempo1
tmp_1_mc_bucle2
   nop
   decfsz _np_tiempo1,1
   goto tmp_1_mc_bucle2
   nop
   nop
   nop
   nop
   nop
   decfsz _np_tiempo,1
   goto tmp_1_mc_bucle1
   return


tmp_100_mc
   movwf _np_tiempo
   goto tmp_100_mc_1
tmp_100_mc_bucle2
   nop
   nop
   nop
   nop
   nop
   nop
   nop
tmp_100_mc_1
   movlw .22
   movwf _np_tiempo1
tmp_100_mc_bucle1
   movlw .150
   movwf _np_tiempo2
tmp_100_mc_bucle
   decfsz _np_tiempo2,1
   goto tmp_100_mc_bucle
   decfsz _np_tiempo1,1
   goto tmp_100_mc_bucle1
   nop
   decfsz _np_tiempo,1
   goto tmp_100_mc_bucle2
   return


multi_100_dec
   
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_temp3
   clrf _np_temp4
   movf _np_temp1,w
   movwf _np_temp6
   clrf _np_temp5
   movlw .07
   movwf _np_temp7
   movf _np_temp1,w
   movwf _np_temp13
   movf _np_temp2,w
   movwf _np_temp14
   movf _np_temp3,w
   movwf _np_temp15
multi_100_dec_a
   decfsz _np_temp7,1
   goto multi_100_dec_b
   goto multi_100_dec_d
multi_100_dec_b
   bcf status,c
   rlf _np_temp6,1
   rlf _np_temp5,1
   movf _np_temp7,w
   xorlw .05
   btfsc status,z
   goto multi_100_dec_c
   movf _np_temp7,w
   xorlw .02
   btfsc status,z
   goto multi_100_dec_c
   movf _np_temp7,w
   xorlw .01
   btfss status,z
   goto multi_100_dec_a
multi_100_dec_c
   movf _np_temp6,w
   addwf _np_temp4,1
   btfsc status,c
   incf _np_temp3,1
   movf _np_temp5,w
   addwf _np_temp3,1
   goto multi_100_dec_a
multi_100_dec_d
   movf _np_temp2,w
   addwf _np_temp4,1
   btfsc status,c
   incf _np_temp3,1
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   return

multi_16
   ;multiplicacion 16 bits x 16 bits = 32 bits
   movlw .16
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   movwf _np_temp9
   clrf _np_temp10
   clrf _np_temp11
   clrf _np_temp12
   clrf _np_temp13
multi_16_1
   clrf _np_temp5
   clrf _np_temp6
   movf _np_temp1,w
   movwf _np_temp7
   movf _np_temp2,w
   movwf _np_temp8
   decfsz _np_temp9,1
   goto multi_16_2
   rlf _np_temp4,1
   btfsc _np_temp3,7
   call multi_16_5                  ;llamada a rutina multi_16_5
   goto multi_16_8
multi_16_2
   btfss _np_temp3,7
   goto multi_16_4
   movf _np_temp9,w
   movwf _np_temp14
multi_16_3
   bcf status,c
   rlf _np_temp8,1
   rlf _np_temp7,1
   rlf _np_temp6,1
   rlf _np_temp5,1
   decfsz _np_temp14,1
   goto multi_16_3
   call multi_16_5                  ;llamada a rutina multi_16_5
multi_16_4
   bcf status,c
   rlf _np_temp4,1
   rlf _np_temp3,1
   goto multi_16_1
multi_16_5
   movf _np_temp8,w
   addwf _np_temp13,1
   btfsc status,c
   call multi_16_6                  ;llamada a rutina multi_16_6
   movf _np_temp7,w
   addwf _np_temp12,1
   btfsc status,c
   call multi_16_7                  ;llamada a rutina multi_16_7
   movf _np_temp6,w
   addwf _np_temp11,1
   btfsc status,c
   incf _np_temp5,1
   movf _np_temp5,w
   addwf _np_temp10,1
   return
multi_16_6
   incf _np_temp7,1
   btfss status,z
   return
   incf _np_temp6,1
   btfsc status,z
   incf _np_temp5,1
   return
multi_16_7
   incf _np_temp6,1
   btfsc status,z
   incf _np_temp5,1
   return
multi_16_8
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   return



division_32
   ;division 32 bits / 32 bits
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_temp14
   clrf _np_temp9
   clrf _np_temp10
   clrf _np_temp11
   clrf _np_temp12
   movlw .32
   movwf _np_temp13
division_32_a
   call division_32_d               ;llamada a rutina division_32_d
   movf _np_temp8,w
   subwf _np_temp12,w
   btfss status,z
   goto division_32_b
   movf _np_temp7,w
   subwf _np_temp11,w
   btfss status,z
   goto division_32_b
   movf _np_temp6,w
   subwf _np_temp10,w
   btfss status,z
   goto division_32_b
   movf _np_temp5,w
   subwf _np_temp9,w
division_32_b
   btfss status,c
   goto division_32_c
   movf _np_temp5,w
   subwf _np_temp9,1
   movf _np_temp6,w
   btfss status,c
   incfsz _np_temp6,w
   subwf _np_temp10,1
   movf _np_temp7,w
   btfss status,c
   incfsz _np_temp7,w
   subwf _np_temp11,1
   movf _np_temp8,w
   btfss status,c
   incfsz _np_temp8,w
   subwf _np_temp12,1
   bcf status,c
   bsf _np_temp1,0
division_32_c
   decfsz _np_temp13,1
   goto division_32_a
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   return
division_32_d
   rlf _np_temp1,1
   rlf _np_temp2,1
   rlf _np_temp3,1
   rlf _np_temp4,1
   rlf _np_temp9,1
   rlf _np_temp10,1
   rlf _np_temp11,1
   rlf _np_temp12,1
   return

conv_8_bcd
   ;convertir un registro a formato bcd (u, d y c)
   bcf status,rp0                   ;cambiar a banco 0
   bcf status,rp1
   clrf _np_bcd_temp3
   clrf _np_bcd_temp2
   movlw .100
conv_8_bcd_otro
   subwf _np_bcd_temp1,1
   btfss status,c
   goto conv_8_bcd_suma
   incf _np_bcd_temp3,1
   goto conv_8_bcd_otro
conv_8_bcd_suma
   addwf _np_bcd_temp1,1
   movlw .10
conv_8_bcd_bucle
   subwf _np_bcd_temp1,1
   btfss status,c
   goto conv_8_bcd_salir
   incf _np_bcd_temp2,1
   goto conv_8_bcd_bucle
conv_8_bcd_salir
   addwf _np_bcd_temp1,1
   return


;------------------------------------------------------------
;                  DATOS EN MEMORIA EEPROM
;------------------------------------------------------------
   org  0x2100
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff
   data   0xff

 End